package com.logicbig.example;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

public class Main {
    private static final EntityManagerFactory emf =
            Persistence.createEntityManagerFactory("testPersistenceUnit");
    private static final EntityManager entityManager = emf.createEntityManager();

    public static void main(String[] args) {
        runNativeQuery("SHOW TABLES");

        //this will print  column name, type, can-be-NULL,
        // KEY and default value  respectively
        runNativeQuery("SHOW COLUMNS from ExampleEntity");

        //Populate entity with an array and persist
        ExampleEntity entity = new ExampleEntity();
        entity.setDates(new Date[]{new Date(), new Date(500000)});
        entityManager.getTransaction().begin();
        entityManager.persist(entity);
        entityManager.getTransaction().commit();

        ExampleEntity entity1 = entityManager.find(ExampleEntity.class, 0);
        Date[] dates = entity1.getDates();
        if (dates != null && dates.length > 0) {
            System.out.println("date loaded from database: ");
            System.out.println(dates[0]);
        }
    }

    private static void runNativeQuery(String s) {
        System.out.println("--------\n" + s);
        Query query = entityManager.createNativeQuery(s);
        List list = query.getResultList();
        for (Object o : list) {
            System.out.println(Arrays.toString((Object[]) o));
        }
    }
}